// $Id: fish.h,v 1.4 2006/08/05 09:08:58 matthew Exp $

//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _FISH_H_
#define _FISH_H_




#include "sprite.h"
#include "constants.h"
#include "SDL.h"
#include "playdisplay.h"
#include "enums.h"




namespace FS
{
    
class Fish : public Sprite
{
    private:
            
        static const int COLL_BOX_X_OFFSET = 5;
        static const int COLL_BOX_Y_OFFSET = 9;
        static const int COLL_BOX_WIDTH = 38;
        static const int COLL_BOX_HEIGHT = 19;
        
        SDL_Rect dest_rect;
        SDL_Rect dirty_rect;
        
        bool fish_taken;
        
    public:
        Fish();
        ~Fish();
        
        void reset();
        
        void draw(PlayDisplay * pd);
        void remove_fish();
        
}; // class Fish

} // namespace FS




#endif

    
