// $Id: gametimer.h,v 1.4 2006/08/05 09:08:59 matthew Exp $

//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _GAME_TIMER_H_
#define _GAME_TIMER_H_




#include "SDL.h"




class GameTimer
{
    private:
        int start_time;    
        int num_ticks_on_pause;        
        bool running;

    public:
        GameTimer();
        ~GameTimer();

        // Returns true if timer running after 'pause', else false.
        bool pause();        
        bool is_running() const { return running; }        
        int get_time() const;
        
        // Simply forces timer to run if it's paused.
        void resume();
        
}; // class GameTimer




#endif

