// $Id: getreadydisplay.h,v 1.4 2006/07/31 18:48:26 matthew Exp $

//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _GETREADYDISPLAY_H_
#define _GETREADYDISPLAY_H_




#include "SDL.h"
#include "Font.hpp" // C++ wrapper for SFont
#include "enums.h"




namespace FS
{
    
class GetReadyDisplay
{
    private:
        static const int SECONDS_TO_WAIT = 10;
    
        SDL_Surface * screen;   // from GameManager
        SDL_Surface * font_gfx;
        SDL_Surface * background;
        
        SFont my_font;    // may need to modify Font.hpp to provide empty constructor
        
        int start_time;
        
    public:
        GetReadyDisplay(SDL_Surface * s);
        ~GetReadyDisplay();
        
        void start_draw(int gt, int lev);
        
        // Returns true if ready to start game, otherwise false.
        bool redraw(int gt, KeyboardEvent * events, int n);
        
}; // class GetReadyDisplay
    
} // namespace FS




#endif
    
